package com.google.inject;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * Annotates methods of a {@link Module} to create a provider method binding. The method's return
 * type is bound to its returned value. Guice will pass dependencies to the method as parameters.
 */
@Documented
@Target(METHOD)
@Retention(RUNTIME)
public @interface Provides {
}
