package com.google.inject.internal;

final class Initializables {

    /**
     * Returns an initializable for an instance that requires no initialization.
     */
    static <T> Initializable<T> of(final T instance) {
        return new Initializable<>() {
            public T get() {
                return instance;
            }

            @Override
            public String toString() {
                return String.valueOf(instance);
            }
        };
    }
}
