package com.google.inject.internal;

import com.google.inject.spi.Dependency;

/**
 * Creates objects which will be injected.
 */
interface InternalFactory<T> {

    /**
     * Creates an object to be injected.
     *
     * @param context of this injection
     * @param linked  true if getting as a result of a linked binding
     * @return instance that was created
     * @throws InternalProvisionException if a value cannot be provided
     */
    T get(InternalContext context, Dependency<?> dependency, boolean linked)
            throws InternalProvisionException;
}
