package com.google.inject.spi;

import com.google.inject.Binder;
import com.google.inject.Binding;

/**
 * A binding to a key exposed from an enclosed private environment.
 *
 */
public interface ExposedBinding<T> extends Binding<T>, HasDependencies {

    /**
     * Returns the enclosed environment that holds the original binding.
     */
    PrivateElements getPrivateElements();

    /**
     * Unsupported. Always throws {@link UnsupportedOperationException}.
     */
    void applyTo(Binder binder);
}