package com.google.inject.spi;

import java.util.Set;

/**
 * Implemented by {@link com.google.inject.Binding bindings}, {@link com.google.inject.Provider
 * providers} and instances that expose their dependencies explicitly.
 */
public interface HasDependencies {

    /**
     * Returns the known dependencies for this type. If this has dependencies whose values are not
     * known statically, a dependency for the {@link com.google.inject.Injector Injector} will be
     * included in the returned set.
     *
     * @return a possibly empty set
     */
    Set<Dependency<?>> getDependencies();
}
