package com.google.inject.spi;

import com.google.inject.Binding;
import com.google.inject.Key;

/**
 * A binding to a linked key. The other key's binding is used to resolve injections.
 */
public interface LinkedKeyBinding<T> extends Binding<T> {

    /**
     * Returns the linked key used to resolve injections. That binding can be retrieved from an
     * injector using {@link com.google.inject.Injector#getBinding(Key) Injector.getBinding(key)}.
     */
    Key<? extends T> getLinkedKey();

}