package com.google.inject;

import static org.junit.Assert.assertNotNull;
import org.junit.Test;

public class SuperclassTest {

    @Test
    public void testSuperclassInjection() throws CreationException {
        Injector injector = Guice.createInjector(new AbstractModule() {
            protected void configure() {
                bind(Foo.class);
            }
        });

        Provider<Sub> creator = injector.getProvider(Sub.class);
        Sub sub = creator.get();
        sub = creator.get();
        sub = creator.get();
        sub = creator.get();
        sub = creator.get();
        assertNotNull(sub.field);
        assertNotNull(sub.fromMethod);
    }

    static abstract class Super {
        @Inject
        Foo field;

        Foo fromMethod;

        @Inject
        void setC(Foo foo) {
            fromMethod = foo;
        }
    }

    static class Sub extends Super {
    }

    static class Foo {
    }
}
